﻿Imports System
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Linq
Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.Threading.Tasks


Public Class MainWindowViewModel
    Implements INotifyPropertyChanged

    Public Sub New()
        Dim drives = DirectoryStructure.GetLogicalDrives()
        Items = New ObservableCollection(Of DirectoryItemViewModel)(drives.[Select](Function(drive) New DirectoryItemViewModel(drive.FullPath, DirectoryItemTypeEnum.Drive)))
    End Sub

    Private _items As ObservableCollection(Of DirectoryItemViewModel)

    Public Property Items As ObservableCollection(Of DirectoryItemViewModel)
        Get
            Return _items
        End Get
        Set(ByVal value As ObservableCollection(Of DirectoryItemViewModel))

            If _items IsNot value Then
                _items = value
                RaisePropertyChanged(NameOf(Items))
            End If
        End Set
    End Property



    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

End Class
